Public Class Form1
    Dim Data(512) As Int16
    Dim Time_Bytes_Print As Integer
    Dim Time_div_set As Byte


    Dim restart_count As Byte
    Dim Byte_RX_Count As Integer

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim ports() As String
        Dim port As String

        'Com Ports suchen und in Liste eintragen
        ports = System.IO.Ports.SerialPort.GetPortNames
        ComboBox1.Text = ports(0)
        For Each port In ports
            ComboBox1.Items.Add(port)
        Next port

        SerialPort1.PortName() = ComboBox1.Text

    End Sub


    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Dim myGrafik As Graphics
        Dim myPen1 As New Pen(Color.YellowGreen, 4)

        Dim count As Integer
        Dim bl As Decimal
        Dim bh As Decimal

        restart_count = restart_count + 1

        If restart_count > 3 Then
            If SerialPort1.IsOpen = True Then
                SerialPort1.Write("GET")
                SerialPort1.Write(Chr(13))
                Byte_RX_Count = 0
                restart_count = 0
            End If
        End If

        If Byte_RX_Count < 390 Then Return

        Byte_RX_Count = 0
        restart_count = 0

        If SerialPort1.IsOpen = True Then
            SerialPort1.Write("GET")
            SerialPort1.Write(Chr(13))
        End If

        bl = PictureBox1.Width
        bl = bl / Time_Bytes_Print

        bh = PictureBox1.Height
        bh = bh / 255

        myGrafik = Graphics.FromHwnd(hwnd:=PictureBox1().Handle)
        PictureBox1.Refresh()

        For count = 1 To Time_Bytes_Print
            myGrafik.DrawLine(myPen1, (count * bl) - bl, Data(count) * bh, (count * bl), Data(count + 1) * bh)
        Next

    End Sub
    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click

        'Button COM Port Open/Close
        If SerialPort1.IsOpen = False Then
            Button6.Text = "CLOSE"
            Button6.BackColor = SystemColors.Control
            ComboBox1.Enabled = False
            SerialPort1.Open()
            Time_print()
            Byte_RX_Count = 0
            Timer1.Start()
        Else
            If Timer1.Enabled Then
                Timer1.Stop()
            End If
            Button6.Text = "OPEN"
            ComboBox1.Enabled = True
            Button6.BackColor = Color.Red
            SerialPort1.Close()
            Timer1.Stop()
        End If
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        SerialPort1.PortName() = ComboBox1.Text
    End Sub

    Private Sub SerialPort1_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived

        Dim count As Integer

        For count = 1 To SerialPort1.BytesToRead
            Data(Byte_RX_Count) = 255 - SerialPort1.ReadByte()
            Byte_RX_Count = Byte_RX_Count + 1
        Next

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        If SerialPort1.IsOpen = True Then
            If Time_div_set < 16 Then
                Time_div_set = Time_div_set + 1
            End If

            Time_print()
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

        If SerialPort1.IsOpen = True Then
            If Time_div_set > 0 Then
                Time_div_set = Time_div_set - 1
            End If
            Time_print()
        End If
    End Sub

    Private Sub Time_print()
        If (Time_Div_Set = 0) Then
            TextBox1.Text = "100 ns"
            Time_Bytes_Print = 60
            '1 * 20ns * 60 Sampels /12Div = 100ns ** H
            SerialPort1.Write("DIV 0,0")
            SerialPort1.Write(Chr(13))
        End If

        If (Time_Div_Set = 1) Then
            TextBox1.Text = "250 ns"
            Time_Bytes_Print = 150
            '1 * 20ns * 150 Sampels /12Div = 250ns ** H
            SerialPort1.Write("DIV 0,0")
            SerialPort1.Write(Chr(13))
        End If

        If (Time_Div_Set = 2) Then
            TextBox1.Text = "500 ns"
            Time_Bytes_Print = 300
            '1 * 20ns * 300 Sampels / 12Div = 500ns ** H
            SerialPort1.Write("DIV 0,0")
            SerialPort1.Write(Chr(13))
        End If

        If (Time_Div_Set = 3) Then
            TextBox1.Text = "1 s"
            Time_Bytes_Print = 300
            '4 * 20ns * 300Sampels / 12 Div = 1005ns ca. 1s ** H
            SerialPort1.Write("DIV 0,1")
            SerialPort1.Write(Chr(13))
        End If
        If (Time_Div_Set = 4) Then
            TextBox1.Text = "2.5 s"
            Time_Bytes_Print = 300

            '5 * 20ns * 300Sampels / 12 Div = 2500ns ca. 2,5s ** H
            SerialPort1.Write("DIV 0,4")
            SerialPort1.Write(Chr(13))
        End If

        If (Time_Div_Set = 5) Then
            TextBox1.Text = "5 s"
            Time_Bytes_Print = 300

            '10 * 20ns * 300Sampels / 12 Div = 5000ns ca. 5s ** H
            SerialPort1.Write("DIV 0,9")
            SerialPort1.Write(Chr(13))
        End If

        If (Time_Div_Set = 6) Then
            TextBox1.Text = "10 s"
            Time_Bytes_Print = 300

            '20 * 20ns * 300 Sampels / 12Div = 10001 ns ca. 10 s ** H
            SerialPort1.Write("DIV 0,19")
            SerialPort1.Write(Chr(13))
        End If

        If (Time_Div_Set = 7) Then
            TextBox1.Text = "25 s"
            Time_Bytes_Print = 385

            '39 * 20ns * 385 Sampels /12Div = 250025 ns ca 25 s ** H
            SerialPort1.Write("DIV 0,38")
            SerialPort1.Write(Chr(13))
        End If

        If (Time_Div_Set = 8) Then
            TextBox1.Text = "50 s"
            Time_Bytes_Print = 188

            '5 * 32 * 20ns * 188 Sampels /12Div = 50133 ns ca 50 s ** H
            SerialPort1.Write("DIV 1,4")
            SerialPort1.Write(Chr(13))
        End If

        If (Time_Div_Set = 9) Then
            TextBox1.Text = "100 s"
            Time_Bytes_Print = 375

            '5 * 32 * 20ns * 375 Sampels /12Div = 100000ns ca 100s ** H
            SerialPort1.Write("DIV 1,4")
            SerialPort1.Write(Chr(13))
        End If

        If (Time_Div_Set = 10) Then
            TextBox1.Text = "250 s"
            Time_Bytes_Print = 261

            '15 * 32 * 20ns * 261 Sampels /12Div = 2505600ns ca 250s ** H
            SerialPort1.Write("DIV 1,14")
            SerialPort1.Write(Chr(13))
        End If

        If (Time_Div_Set = 11) Then
            TextBox1.Text = "500 s"
            Time_Bytes_Print = 355

            '22 * 32 * 20ns * 355Sampels /12Div = 4998400ns ca 500s ** H
            SerialPort1.Write("DIV 1,21")
            SerialPort1.Write(Chr(13))
        End If

        If (Time_Div_Set = 12) Then
            TextBox1.Text = "1 ms"
            Time_Bytes_Print = 71

            '33 * 256 * 20ns * 71Sampels /12Div = 999680ns ca 1ms
            SerialPort1.Write("DIV 2,32")
            SerialPort1.Write(Chr(13))
        End If

        If (Time_Div_Set = 13) Then
            TextBox1.Text = "2.5 ms"
            Time_Bytes_Print = 90

            '65 * 256 * 20ns * 90Sampels /12Div = 2496000ns ca 2.5ms
            SerialPort1.Write("DIV 2,64")
            SerialPort1.Write(Chr(13))
        End If

        If (Time_Div_Set = 14) Then
            TextBox1.Text = "5 ms"
            Time_Bytes_Print = 180

            '65 * 256 * 20ns * 180Sampels /12Div = 4992000ns ca 5ms
            SerialPort1.Write("DIV 2,64")
            SerialPort1.Write(Chr(13))
        End If
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        SerialPort1.Write("AC")
        SerialPort1.Write(Chr(13))
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        SerialPort1.Write("DC")
        SerialPort1.Write(Chr(13))
    End Sub

    Private Sub TrackBar2_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar2.Scroll

    End Sub

    Private Sub TrackBar1_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar1.Scroll
        Dim offset As Byte
        offset = TrackBar1.Value
        If SerialPort1.IsOpen = True Then
            SerialPort1.Write("OFFSET")
            SerialPort1.Write(Str(offset))
            SerialPort1.Write(Chr(13))
        End If
    End Sub
End Class
